package com.gree.mall.contest.controller.pc.admin;


import cn.hutool.core.lang.TypeReference;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.gree.mall.contest.annotation.ZfireList;
import com.gree.mall.contest.bean.admin.AdminFastEntryVO;
import com.gree.mall.contest.bean.zfire.ZfireParamBean;
import com.gree.mall.contest.helper.ResponseHelper;
import com.gree.mall.contest.logic.admin.AdminFastEntryLogic;
import com.gree.mall.contest.plus.entity.AdminFastEntry;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;

@RequiredArgsConstructor
@RestController
@Tag(name = "系统快捷入口", description = "系统快捷入口")
@RequestMapping("/pc/admin/fast/entry")
public class AdminFastEntryController {

    private final AdminFastEntryLogic adminFastEntryLogic;

    @ZfireList
    @PostMapping("list")
    @Operation(summary = "列表")
    public ResponseHelper<IPage<AdminFastEntryVO>> list(@RequestBody(required = false) ZfireParamBean zfireParamBean) {
        IPage<AdminFastEntryVO> adminFastEntryVOIPage = adminFastEntryLogic.listPage(zfireParamBean);
        return ResponseHelper.success(adminFastEntryVOIPage, new TypeReference<AdminFastEntryVO>() {});
    }

    @GetMapping("detail")
    @Operation(summary = "详情")
    public ResponseHelper<AdminFastEntry> detail(@RequestParam(required = true) String id) {
        AdminFastEntry detail = adminFastEntryLogic.detail(id);
        return ResponseHelper.success(detail);
    }

    @PostMapping("add")
    @Operation(summary = "新增")
    public ResponseHelper add(@RequestBody AdminFastEntry adminFastEntry) {
        adminFastEntryLogic.add(adminFastEntry);
        return ResponseHelper.success();
    }

    @PostMapping("update")
    @Operation(summary = "修改")
    public ResponseHelper update(@RequestBody AdminFastEntry adminFastEntry) {
        adminFastEntryLogic.update(adminFastEntry);
        return ResponseHelper.success();
    }

    @PostMapping("delete")
    @Operation(summary = "删除")
    public ResponseHelper delete(@RequestParam String id) {
        adminFastEntryLogic.delete(id);
        return ResponseHelper.success();
    }
}
